import unit4.collectionsLib.List;
import unit4.collectionsLib.Node;
import unit4.utilsLib.ListUtils;

public class MergeLists 
{
	public static void main(String[] args) 
	{
		System.out.println("     ");
		List<Integer> list1 = ListUtils.createRandomList(5, -100, 100);
		List<Integer> list2 = ListUtils.createRandomList(10, -100, 100);
		System.out.println(list1);
		System.out.println(list2);
		System.out.println("-----------------------------------------------");
		
		
		System.out.println(" ");
		list1 = mergeSort(list1);
		list2 = mergeSort(list2);
		System.out.println(list1);
		System.out.println(list2);
		System.out.println("-----------------------------------------------");
		
		
		System.out.println(" ");
		System.out.println(mergeLists(list1, list2));
		System.out.println("-----------------------------------------------");
	}
	
		
	//       
	public static List<Integer> mergeLists(List<Integer> list1, List<Integer> list2)
	{
		Node<Integer> pos1 = list1.getFirst();
		Node<Integer> pos2 = list2.getFirst();
		Node<Integer> pos3 = null;
		
		List<Integer> list3 = new List<Integer>();		
		
		while(pos1!=null && pos2!=null)
		{
			int small;
			if(pos1.getInfo() < pos2.getInfo())
			{
				small = pos1.getInfo();
				pos1 = pos1.getNext();
			}
			else
			{
				 small = pos2.getInfo();
				 pos2 = pos2.getNext();
			}
			pos3 = list3.insert(pos3,small);
		}
		
		while(pos1!=null)
		{
			pos3 = list3.insert(pos3,pos1.getInfo());
			pos1 = pos1.getNext();
		}
		
		while(pos2!=null)
		{
			pos3 = list3.insert(pos3,pos2.getInfo());
			pos2 = pos2.getNext();
		}
		
		return(list3);
	}


	//    
	public static List<Integer>[] splitList(List<Integer> list)
	{
		List<Integer>[] split = new List[2]; 
		
		split[0] = new List<Integer>();
		split[1] = new List<Integer>();
		
		Node<Integer> pos1 = list.getFirst();
		Node<Integer> pos2 = list.getFirst();
		Node<Integer> pos3 = null;
		
		while(pos2!=null && pos2.getNext()!=null)
		{
			pos3 = split[0].insert(pos3,pos1.getInfo());
			pos1 = pos1.getNext();
			pos2 = pos2.getNext().getNext();
		}
		
		pos3 = null;
		while(pos1 != null)
		{
			pos3 = split[1].insert(pos3,pos1.getInfo());
			pos1 = pos1.getNext();
		}
		
		return(split);
	}

	//   
	public static List<Integer> mergeSort(List<Integer> list)
	{
		List<Integer> sortedList;
		
		if(list.getFirst().getNext() == null) //     
		{
			sortedList = new List<Integer>();
			sortedList.insert(null, list.getFirst().getInfo());
		}
		else
		{
			List<Integer>[] split = splitList(list);
			List<Integer> left = mergeSort(split[0]);
			List<Integer> right = mergeSort(split[1]);
			sortedList = mergeLists(left, right);
		}
		
		return(sortedList);
	}
}